#ifndef NEWMADCALC_H
#define NEWMADCALC_H
#include "madcalc.h"   //В ковычках ищет сначала в папке программы, а затем в папках где находятся библиотеки
#include "QMainWindow"
#include "prog.h"
#include "about.h"
#include <QCloseEvent> //Без ковычек ищет конкретно в папках библиотек

namespace Ui {
class newmadcalc;
}

class newmadcalc : public QMainWindow
{
    Q_OBJECT

public:
    explicit newmadcalc(QWidget *parent = nullptr);
    ~newmadcalc();
      Ui::newmadcalc *ui;

      void abortOperation(); //Объявляем функцию отмены операции (в связи с ошибкой)
      void StatusBar(); //Объявляем функцию статус-бара, чтобы выводить туда сообщение. В этом случае там будет про сумму, записанную в памяти.
      bool calculate (double rightOperand, const QString &pendingOperator);
      double sumInMemory = 0.0; //Переменная для реализации кнопок управления памятью.
      double num = 0.0;         //Переменная для хранения первого операнда
      double snum = 0.0;        //переменная для хранения показателя степени
      bool waitingForOperand;   //переменная двоичного типа (false или true) для того чтобы определиться, ждем мы следующего операнда или нет
      QString clickedOperator = "";
      bool perState = false;    //Флаг оператора процентов для выражений вроде 12% + 60
      double PER;               //Вот эта переменная нужна для функции void Percent(); чтобы вычислять проценты
      double digitValue;        //Переменная для хранения набираемых цифирек
      QString LCD2;             //Переменная для хранения содержимого второго экрана
      void moveToCenter();      //функция для выравнивания окна по центру экрана
      bool ShiftState = false;  //Флаг положения кнопки Shift
      double Pi = 3.1415926535897932384626433832795; //Ебанистически точное значение числа Пи
      QString GradeState ="Deg"; //Положение радиобатона угловой меры в норме

public slots:

void _Pi_();
void SetTextOnLCD1();          //Лишняя незадействованная функция
void Prog();                   //Переключение в режим программиста
void Main();                   //Основной режим
void Grade();                  //Установка режима угловой меры
void rbGrade();                //Радиобатоны управления режима углловой меры
void digitClicked();           //Обработчик нажатия цифровых кнопок из GUI
void unaryOperatorClicked();   //Унарные операторы
void Operator();               //Данная функция считывает текст нажатой кнопки и передает дальше
void OperatorSender();         //А именно сюда. Это разделение нужно чтобы подключить клавиатуру
void root();                   //Вычисление корня
void equalClicked();           //Функция знака =
void btnDot();                 //Это если нажать "точку" Dot(".")
void funcPM();                 //Умножает число на lcd1 на -1, нужно для кнопки +/-
void Backspase();              //Функция удаления последнего знака
void Digit();                  //Обработчик нажатия всех кнопок, как с GUI так и с клавиатуры
void Percent();                //Объявляем функцию вычисления процентов
void Log();                    //Вычисляем логарифм x по основанию a
void Exponentiation();         //Возведение в степень
void CE();                     //Функция сброса текущего операнда
void ClearAll();               //Функция сброса вычислений
void About();                  //Функция вызова формы about
void Shift();                  //Задействовать доп функции

//Блок управления памятью
void setMemory();              //Записать в память
void clearMemory();            //Очистить память
void readMemory();             //Прочесть память и вывести на экран
void subtMemory();             //Вычесть из числа в памяти число с экрана
void addToMemory();            //Прибавить к записанному в памяти числу содержимое экрана lcd1



protected:
   virtual void keyPressEvent(QKeyEvent *event); //Здесь заканчивается конструкция которая позволяет вводить цифры с клавиатуры



private:

about *formAbout;

void closeEvent(QCloseEvent *event);


private slots:

#ifdef DEBUG
void on_btnCtg_clicked();
#endif
};

#endif // NEWMADCALC_H
