#include "prog.h"
#include "ui_prog.h"
#include "newmadcalc.h"
#include "madcalc.h"
#include "QDesktopWidget"


prog::prog(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::prog)
{
    setWindowFlags(Qt::Dialog | Qt::MSWindowsFixedSizeDialogHint); //Данная строчка запрещает изменение размеров окна


    ui->setupUi(this);

    connect(ui->btnMain, SIGNAL(clicked()), this, SLOT(Main()));
    connect(ui->btnEn, SIGNAL(clicked()), this, SLOT(En()));
    moveToCenter();
}

void prog::moveToCenter(){
    QRect rect = frameGeometry();
    rect.moveCenter(QDesktopWidget().availableGeometry().center());
    move(rect.topLeft());
}


prog::~prog()
{
    delete ui;
}

void prog::Main()
{
    this->hide();
    madCalc *frm = new madCalc();
                     frm->show();
}

void prog::En()
{
    this->hide();
    newmadcalc *frm = new newmadcalc();
                           frm->show();
}
